"""MSWord doc to text file converter for Document Library"""

from os import listdir, popen, remove, path
from Globals import package_home
from time import time

content_type = 'application/msword'

content_description = """Microsoft Word [<a href="http://officeupdate.microsoft.com/downloadDetails/wd97vwr32.htm" target="_blank">Download MS Word Viewer</a>]"""

tmp_path = '/tmp'
wvConf_file = path.join(package_home(globals()), 'wvText.xml')

# Uses the wvWare, and assumes it is in the path
# Requires write access to /tmp

def convert(data):
    """Convert MSWord data to raw text"""
    
    tmp_dir = listdir(tmp_path)
    tmp_name = ''

    while (not tmp_name) or (tmp_name in tmp_dir):
        # Pick a unique name for the tmp file
        tmp_name = tmp_path + '/doc_tmp_' + str(time())
    
    tmp_file = open(tmp_name, 'wb')
    tmp_file.write(data)
    tmp_file.close()
    text = popen('wvWare -x %s %s' % (wvConf_file, tmp_name)).read()
    remove(tmp_name)
    
    return text

# For increased speed, comment out line 400 of text.c in the wv source
